Codeforces Edu 74 E. Keyboard Purchase 【状压DP +贡献】

2024-02-10 01:44

本文主要是介绍Codeforces Edu 74 E. Keyboard Purchase 【状压DP +贡献】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

E. Keyboard Purchase

E

题意

给定一个长度为 n n n 的字符串 s s s 仅由前 m m m 个小写字母组成

现在要求求出包含前 m m m 个小写字母的键盘,使得在键盘上敲出 s s s 要移动的距离最短

移动总距离为: ∑ i = 2 n ∣ p o s s i − 1 − p o s s i ∣ \sum_{i = 2}^{n} | pos_{s_{i - 1}} - pos_{s_{i}}| i=2npossi1possi

p o s s i pos_{s_i} possi s i s_i si 在键盘上的位置

思路

由于 m m m 很小,我们考虑在键盘上跑状压 D P DP DP,如果当前已经排好了集合 S S S 中的那些位,枚举当前的字母的话,假设当前枚举的不在 S S S 中的字母为 i i i,那么我们就需要找到 s s s 中和字母 i i i 相邻的那些字母 j j j,因为它们相邻,所以要 j → i j \rightarrow i ji i → j i \rarr j ij 移动,这个移动是在键盘上移动的。我们不妨以 c n t [ i ] [ j ] cnt[i][j] cnt[i][j] 来表示原 s s s 中相邻的 i − j i-j ij 配对数量

那么这一位放 i i i 的贡献为:

  • ∑ j ∈ S c n t [ j ] [ i ] × ( p o s i − p o s j ) \sum_{j \in S} cnt[j][i] \times (pos_i - pos_j) jScnt[j][i]×(posiposj)
  • ∑ j ∉ S c n t [ j ] [ i ] × ( p o s j − p o s i ) \sum_{j \notin S} cnt[j][i] \times (pos_j - pos_i) j/Scnt[j][i]×(posjposi)

对于 j j j 是否已经在 S S S 中分开考虑,已经在 S S S 中的 j j j,后放置的 i i i p o s i pos_i posi 一定大于 p o s j pos_j posj,反之也很容易得出相应结论。

那么我们把贡献中包含小标 i i i 的提取出来,就变成了只和 i i i 相关的贡献:

  • ∑ j ∈ S c n t [ j ] [ i ] × p o s i \sum_{j \in S} cnt[j][i] \times pos_i jScnt[j][i]×posi
  • ∑ j ∉ S c n t [ j ] [ i ] × ( − p o s i ) \sum_{j \notin S} cnt[j][i] \times (-pos_i) j/Scnt[j][i]×(posi)

这就是 i i i 的贡献了,可以发现:把所有字母的贡献加起来,一定是这个放置顺序的答案

我们只需要从贡献这个角度切入就可以很容易得出状压 D P DP DP 的转移

时间复杂度: O ( m 2 ⋅ 2 m ) O(m^2 \cdot 2^m) O(m22m)

#include<bits/stdc++.h>
#define fore(i,l,r)	for(int i=(int)(l);i<(int)(r);++i)
#define fi first
#define se second
#define endl '\n'
#define ull unsigned long long
#define ALL(v) v.begin(), v.end()
#define Debug(x, ed) std::cerr << #x << " = " << x << ed;const int INF=0x3f3f3f3f;
const long long INFLL=1e18;typedef long long ll;const int M = 21;int cnt[M][M];
int dp[1 << M];int main(){std::ios::sync_with_stdio(false);std::cin.tie(nullptr);std::cout.tie(nullptr);int n, m;std::cin >> n >> m;std::string s;std::cin >> s;fore(i, 1, n){++cnt[s[i] - 'a'][s[i - 1] - 'a'];++cnt[s[i - 1] - 'a'][s[i] - 'a'];}memset(dp, INF, sizeof(dp));dp[0] = 0;fore(S, 0, 1 << m)fore(i, 0, m)if(!(S >> i & 1)){int nS = S | 1 << i;int res = 0;int pos = __builtin_popcount(S);fore(j, 0, m){if(i == j) continue;if(S >> j & 1) res += cnt[i][j] * pos;else res -= cnt[i][j] * pos;}dp[nS] = std::min(dp[nS], dp[S] + res);}std::cout << dp[(1 << m) - 1];return 0;
}

这篇关于Codeforces Edu 74 E. Keyboard Purchase 【状压DP +贡献】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/695829

相关文章

hdu4826(三维DP)

这是一个百度之星的资格赛第四题 题目链接:http://acm.hdu.edu.cn/contests/contest_showproblem.php?pid=1004&cid=500 题意:从左上角的点到右上角的点,每个点只能走一遍,走的方向有三个:向上,向下,向右,求最大值。 咋一看像搜索题,先暴搜,TLE,然后剪枝,还是TLE.然后我就改方法,用DP来做,这题和普通dp相比,多个个向上

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu4865(概率DP)

题意:已知前一天和今天的天气概率,某天的天气概率和叶子的潮湿程度的概率,n天叶子的湿度,求n天最有可能的天气情况。 思路:概率DP,dp[i][j]表示第i天天气为j的概率,状态转移如下:dp[i][j] = max(dp[i][j, dp[i-1][k]*table2[k][j]*table1[j][col] )  代码如下: #include <stdio.h>#include

usaco 1.1 Broken Necklace(DP)

直接上代码 接触的第一道dp ps.大概的思路就是 先从左往右用一个数组在每个点记下蓝或黑的个数 再从右到左算一遍 最后取出最大的即可 核心语句在于: 如果 str[i] = 'r'  ,   rl[i]=rl[i-1]+1, bl[i]=0 如果 str[i] = 'b' ,  bl[i]=bl[i-1]+1, rl[i]=0 如果 str[i] = 'w',  bl[i]=b

uva 10154 DP 叠乌龟

题意: 给你几只乌龟,每只乌龟有自身的重量和力量。 每只乌龟的力量可以承受自身体重和在其上的几只乌龟的体重和内。 问最多能叠放几只乌龟。 解析: 先将乌龟按力量从小到大排列。 然后dp的时候从前往后叠,状态转移方程: dp[i][j] = dp[i - 1][j];if (dp[i - 1][j - 1] != inf && dp[i - 1][j - 1] <= t[i]

uva 10118 dP

题意: 给4列篮子,每次从某一列开始无放回拿蜡烛放入篮子里,并且篮子最多只能放5支蜡烛,数字代表蜡烛的颜色。 当拿出当前颜色的蜡烛在篮子里存在时,猪脚可以把蜡烛带回家。 问最多拿多少只蜡烛。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cs

uva 10069 DP + 大数加法

代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>#include <cl

uva 10029 HASH + DP

题意: 给一个字典,里面有好多单词。单词可以由增加、删除、变换,变成另一个单词,问能变换的最长单词长度。 解析: HASH+dp 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#inc

XTU 1233 n个硬币连续m个正面个数(dp)

题面: Coins Problem Description: Duoxida buys a bottle of MaiDong from a vending machine and the machine give her n coins back. She places them in a line randomly showing head face or tail face o

dp算法练习题【8】

不同二叉搜索树 96. 不同的二叉搜索树 给你一个整数 n ,求恰由 n 个节点组成且节点值从 1 到 n 互不相同的 二叉搜索树 有多少种?返回满足题意的二叉搜索树的种数。 示例 1: 输入:n = 3输出:5 示例 2: 输入:n = 1输出:1 class Solution {public int numTrees(int n) {int[] dp = new int